Subject: Re: [hybi] hybi Digest, Vol 94, Issue 1

From: Scott Morgan <[email-masked]>
Date: Tue, 23 Jul 2019 10:48:48 -0500

+1 to WebTransport, I have been building that sort of thing in to
applications directly, so it would eventually reduce code that I need to
manage/maintain.
https://tools.ietf.org/html/draft-adligo-hybi-asbp-02

On Tue, Jul 23, 2019 at 10:39 AM <[email-masked]> wrote:

> Send hybi mailing list submissions to
>         [email-masked]
>
> To subscribe or unsubscribe via the World Wide Web, visit
>         https://www.ietf.org/mailman/listinfo/hybi
> or, via email, send a message with subject or body 'help' to
>         [email-masked]
>
> You can reach the person managing the list at
>         [email-masked]
>
> When replying, please edit your Subject line so it is more specific
> than "Re: Contents of hybi digest..."
>
>
> Today's Topics:
>
>    1. WebTransport Side Meeting (Tuesday, 15:20) (Victor Vasiliev)
>    2. Re: WebTransport Side Meeting (Tuesday, 15:20) (Andy Green)
>    3. Re: WebTransport Side Meeting (Tuesday, 15:20) (Eric Kinnear)
>    4. Re: [dispatch]  WebTransport Side Meeting (Tuesday, 15:20)
>       (Peter Thatcher)
>
>
> ----------------------------------------------------------------------
>
> Message: 1
> Date: Mon, 22 Jul 2019 16:36:19 -0400
> From: Victor Vasiliev <[email-masked]>
> To: [email-masked], David Schinazi <[email-masked]>
> Cc: IETF QUIC WG <[email-masked]>, HTTP Working Group
>         <[email-masked]>, [email-masked]
> Subject: [hybi] WebTransport Side Meeting (Tuesday, 15:20)
> Message-ID:
>         <
> [email-masked]>
> Content-Type: text/plain; charset="utf-8"
>
> Hello everyone,
>
> Today, at the dispatch working group meeting (18:10), I am going to present
> WebTransport. WebTransport is a protocol framework that allows multiplexed
> and datagram-oriented transport protocols to be used by the web
> applications (think ?WebSocket for UDP?).
>
> Since it?s quite likely we will run out of time during dispatch, I
> scheduled a side-meeting to discuss this in more depth. Below are the side
> meeting details.
>
> *Time:* Tuesday, 15:20 ~ 16:50
> *Place:* Room C2 (21st floor)
> *Organizers:* Victor Vasiliev, David Schinazi
> *Agenda:*
>
>    1. A more in-depth overview of WebTransport.
>    2. Discussion of the overall design and the use cases.
>    3. As time permits, some of the major outstanding design issues in Web
>    transport, e.g.:
>       - What fallback protocol to use?
>       - How to multiplex streams and datagrams within a single connection?
>       - Can we let web applications do their own congestion control?
>       - Should WebTransport sessions have URLs associated with them?
>
> As usual, here are some helpful links:
>
>    - WebTransport overview:
>    https://tools.ietf.org/html/draft-vvv-webtransport-overview-00
>    - QuicTransport:
>    https://tools.ietf.org/html/draft-vvv-webtransport-quic-00
>    - Http3Transport:
>    https://tools.ietf.org/html/draft-vvv-webtransport-http3-00
>    - Web API Spec draft: https://wicg.github.io/web-transport/
>    - Discussion on use cases:
>    https://discourse.wicg.io/t/webtransport-proposal/3508
>
> Cheers,
>   Victor.
> -------------- next part --------------
> An HTML attachment was scrubbed...
> URL: <
> https://mailarchive.ietf.org/arch/browse/hybi/attachments/20190722/f43b7819/attachment.html
> >
>
> ------------------------------
>
> Message: 2
> Date: Mon, 22 Jul 2019 13:59:57 -0700
> From: Andy Green <[email-masked]>
> To: Victor Vasiliev <vasilvv=[email-masked]>,
>         [email-masked],  David Schinazi <[email-masked]>
> Cc: [email-masked], IETF QUIC WG <[email-masked]>, HTTP Working Group
>         <[email-masked]>
> Subject: Re: [hybi] WebTransport Side Meeting (Tuesday, 15:20)
> Message-ID: <[email-masked]>
> Content-Type: text/plain; charset=utf-8; format=flowed
>
>
>
> On 7/22/19 1:36 PM, Victor Vasiliev wrote:
> > Hello everyone,
> >
> > Today, at the dispatch working group meeting (18:10), I am going to
> > present WebTransport. WebTransport is a protocol framework that allows
> > multiplexed and datagram-oriented transport protocols to be used by the
> > web applications (think ?WebSocket for UDP?).
>
> "Historically, web applications that needed bidirectional data stream
>     between a client and a server could rely on WebSockets [RFC6455], a
>     message-based protocol compatible with Web security model.  However,
>     since the abstraction it provides is a single ordered stream of
>     messages, it suffers from head-of-line blocking (HOLB), meaning that
>     all messages must be sent and received in order even if they are
>     independent and some of them are no longer needed.  This makes it a
>     poor fit for latency sensitive applications which rely on partial
>     reliability and stream independence for performance."
>
> The HOLB isn't really entirely the case... RFC6455 ws allows arbitrary
> fragmentation of messages allowing interleaving with control frames.
>
> ws-over-h2 allows you to can the h2 stream when you want as well.
>
> " Each new stream would require a WebSocket handshake to agree on
>        application protocol used, meaning that it would take at least one
>        RTT for each new stream before the client can write to it."
>
> Yes it was knowingly done as a hack to try to encourage uptake from
> browser vendors... it's not really integrated into the encapsulating
> protocol.
>
> >   * WebTransport overview:
> >     https://tools.ietf.org/html/draft-vvv-webtransport-overview-00
> >   * QuicTransport:
> >     https://tools.ietf.org/html/draft-vvv-webtransport-quic-00
> >   * Http3Transport:
> >     https://tools.ietf.org/html/draft-vvv-webtransport-http3-00
>
> There's no h2 transport implementation?
>
> Not everything that might want to use this will get h3 capability in a
> reasonable timeframe.  If there's more momentum behind it than RFC8441
> there's probably room for a generic long-lived bidirectional extension
> to h2 either reusing DATA or a new frame type.
>
> It's a good idea to have it ride on other protocols.  Not doing this
> really hurt RFC6455 ws since deploying it usually needed extra,
> different servers with the attendant difficulties interoperating with
> other protocols.
>
> I really suggest thinking through the effects of not having an RFC6455
> type subprotocol (unless I failed to spot it).  It really makes an
> implicit assumption about what the stream will carry that doesn't scale
> beyond one server carrying one thing.  That's not how things tend to pan
> out if the protocol is useful.  The url path could be hacked to imply
> the subprotocol but if that's not standardized it's still a mess.  And
> the subprotocol binding may be orthogonal to the url layout complicating
> things needlessly.
>
> -Andy
>
> >   * Web API Spec draft: https://wicg.github.io/web-transport/
> >   * Discussion on use cases:
> >     https://discourse.wicg.io/t/webtransport-proposal/3508
> >
> > Cheers,
> >  ? Victor.
> >
> > _______________________________________________
> > hybi mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/hybi
> >
>
>
>
> ------------------------------
>
> Message: 3
> Date: Mon, 22 Jul 2019 17:29:09 -0400
> From: Eric Kinnear <[email-masked]>
> To: Andy Green <[email-masked]>
> Cc: Victor Vasiliev <vasilvv=[email-masked]>,
>         [email-masked],  David Schinazi <[email-masked]>,
>         [email-masked], IETF QUIC WG <[email-masked]>, HTTP Working Group
>         <[email-masked]>
> Subject: Re: [hybi] WebTransport Side Meeting (Tuesday, 15:20)
> Message-ID: <[email-masked]>
> Content-Type: text/plain; charset=utf-8
>
>
>
> > On Jul 22, 2019, at 4:59 PM, Andy Green <[email-masked]> wrote:
> >
> >
> >
> > On 7/22/19 1:36 PM, Victor Vasiliev wrote:
> >> Hello everyone,
> >> Today, at the dispatch working group meeting (18:10), I am going to
> present WebTransport. WebTransport is a protocol framework that allows
> multiplexed and datagram-oriented transport protocols to be used by the web
> applications (think ?WebSocket for UDP?).
> >
> > "Historically, web applications that needed bidirectional data stream
> >   between a client and a server could rely on WebSockets [RFC6455], a
> >   message-based protocol compatible with Web security model.  However,
> >   since the abstraction it provides is a single ordered stream of
> >   messages, it suffers from head-of-line blocking (HOLB), meaning that
> >   all messages must be sent and received in order even if they are
> >   independent and some of them are no longer needed.  This makes it a
> >   poor fit for latency sensitive applications which rely on partial
> >   reliability and stream independence for performance."
> >
> > The HOLB isn't really entirely the case... RFC6455 ws allows arbitrary
> fragmentation of messages allowing interleaving with control frames.
> >
> > ws-over-h2 allows you to can the h2 stream when you want as well.
> >
> > " Each new stream would require a WebSocket handshake to agree on
> >      application protocol used, meaning that it would take at least one
> >      RTT for each new stream before the client can write to it."
> >
> > Yes it was knowingly done as a hack to try to encourage uptake from
> browser vendors... it's not really integrated into the encapsulating
> protocol.
> >
> >>  * WebTransport overview:
> >>    https://tools.ietf.org/html/draft-vvv-webtransport-overview-00
> >>  * QuicTransport:
> >>    https://tools.ietf.org/html/draft-vvv-webtransport-quic-00
> >>  * Http3Transport:
> >>    https://tools.ietf.org/html/draft-vvv-webtransport-http3-00
> >
> > There's no h2 transport implementation?
> >
> > Not everything that might want to use this will get h3 capability in a
> reasonable timeframe.  If there's more momentum behind it than RFC8441
> there's probably room for a generic long-lived bidirectional extension to
> h2 either reusing DATA or a new frame type.
>
> Definitely agree! I know that we?ve been chatting a bit with Victor about
> https://datatracker.ietf.org/doc/draft-kinnear-httpbis-http2-transport/
> which aims to provide this, and I think it would be worth making sure that
> this works nicely with WebTransport.
> -00 for that document covers effectively what you?d get with a new frame
> type, and -01 extends 8441 to cover more than just WebSockets with the
> extended CONNECT handshake.
> I don?t have a particularly strong preference for the mechanism used, but
> rather care more about the outcome ? very much agree that this is a useful
> component.
>
> Thanks,
> Eric
>
> >
> > It's a good idea to have it ride on other protocols.  Not doing this
> really hurt RFC6455 ws since deploying it usually needed extra, different
> servers with the attendant difficulties interoperating with other protocols.
> >
> > I really suggest thinking through the effects of not having an RFC6455
> type subprotocol (unless I failed to spot it).  It really makes an implicit
> assumption about what the stream will carry that doesn't scale beyond one
> server carrying one thing.  That's not how things tend to pan out if the
> protocol is useful.  The url path could be hacked to imply the subprotocol
> but if that's not standardized it's still a mess.  And the subprotocol
> binding may be orthogonal to the url layout complicating things needlessly.
> >
> > -Andy
> >
> >>  * Web API Spec draft: https://wicg.github.io/web-transport/
> >>  * Discussion on use cases:
> >>    https://discourse.wicg.io/t/webtransport-proposal/3508
> >> Cheers,
> >>   Victor.
> >> _______________________________________________
> >> hybi mailing list
> >> [email-masked]
> >> https://www.ietf.org/mailman/listinfo/hybi
> >
>
>
>
> ------------------------------
>
> Message: 4
> Date: Tue, 23 Jul 2019 11:37:04 -0400
> From: Peter Thatcher <[email-masked]>
> To: Eric Kinnear <ekinnear=[email-masked]>
> Cc: Andy Green <[email-masked]>, Victor Vasiliev
>         <vasilvv=[email-masked]>, [email-masked],  David
> Schinazi
>         <[email-masked]>, [email-masked],  HTTP Working Group
>         <[email-masked]>, IETF QUIC WG <[email-masked]>
> Subject: Re: [hybi] [dispatch]  WebTransport Side Meeting (Tuesday,
>         15:20)
> Message-ID:
>         <
> [email-masked]>
> Content-Type: text/plain; charset="utf-8"
>
> At a quick glance,
>
> https://datatracker.ietf.org/doc/draft-kinnear-httpbis-http2-transport/?include_text=1
> seems
> like a decent fit for the WebTransport  API.  It seems better than trying
> to fit the WebSocket API.  But do we expect people to implement it on
> servers before they implement QUIC?  I suppose even if it takes longer, it
> may have the advantage of working on more networks than QUIC and HTTP/3
> potentially (for networks that still block UDP, for example).
>
>
>
> On Mon, Jul 22, 2019 at 5:29 PM Eric Kinnear <ekinnear=
> [email-masked]> wrote:
>
> >
> >
> > > On Jul 22, 2019, at 4:59 PM, Andy Green <[email-masked]> wrote:
> > >
> > >
> > >
> > > On 7/22/19 1:36 PM, Victor Vasiliev wrote:
> > >> Hello everyone,
> > >> Today, at the dispatch working group meeting (18:10), I am going to
> > present WebTransport. WebTransport is a protocol framework that allows
> > multiplexed and datagram-oriented transport protocols to be used by the
> web
> > applications (think ?WebSocket for UDP?).
> > >
> > > "Historically, web applications that needed bidirectional data stream
> > >   between a client and a server could rely on WebSockets [RFC6455], a
> > >   message-based protocol compatible with Web security model.  However,
> > >   since the abstraction it provides is a single ordered stream of
> > >   messages, it suffers from head-of-line blocking (HOLB), meaning that
> > >   all messages must be sent and received in order even if they are
> > >   independent and some of them are no longer needed.  This makes it a
> > >   poor fit for latency sensitive applications which rely on partial
> > >   reliability and stream independence for performance."
> > >
> > > The HOLB isn't really entirely the case... RFC6455 ws allows arbitrary
> > fragmentation of messages allowing interleaving with control frames.
> > >
> > > ws-over-h2 allows you to can the h2 stream when you want as well.
> > >
> > > " Each new stream would require a WebSocket handshake to agree on
> > >      application protocol used, meaning that it would take at least one
> > >      RTT for each new stream before the client can write to it."
> > >
> > > Yes it was knowingly done as a hack to try to encourage uptake from
> > browser vendors... it's not really integrated into the encapsulating
> > protocol.
> > >
> > >>  * WebTransport overview:
> > >>    https://tools.ietf.org/html/draft-vvv-webtransport-overview-00
> > >>  * QuicTransport:
> > >>    https://tools.ietf.org/html/draft-vvv-webtransport-quic-00
> > >>  * Http3Transport:
> > >>    https://tools.ietf.org/html/draft-vvv-webtransport-http3-00
> > >
> > > There's no h2 transport implementation?
> > >
> > > Not everything that might want to use this will get h3 capability in a
> > reasonable timeframe.  If there's more momentum behind it than RFC8441
> > there's probably room for a generic long-lived bidirectional extension to
> > h2 either reusing DATA or a new frame type.
> >
> > Definitely agree! I know that we?ve been chatting a bit with Victor about
> > https://datatracker.ietf.org/doc/draft-kinnear-httpbis-http2-transport/
> > which aims to provide this, and I think it would be worth making sure
> that
> > this works nicely with WebTransport.
> > -00 for that document covers effectively what you?d get with a new frame
> > type, and -01 extends 8441 to cover more than just WebSockets with the
> > extended CONNECT handshake.
> > I don?t have a particularly strong preference for the mechanism used, but
> > rather care more about the outcome ? very much agree that this is a
> useful
> > component.
> >
> > Thanks,
> > Eric
> >
> > >
> > > It's a good idea to have it ride on other protocols.  Not doing this
> > really hurt RFC6455 ws since deploying it usually needed extra, different
> > servers with the attendant difficulties interoperating with other
> protocols.
> > >
> > > I really suggest thinking through the effects of not having an RFC6455
> > type subprotocol (unless I failed to spot it).  It really makes an
> implicit
> > assumption about what the stream will carry that doesn't scale beyond one
> > server carrying one thing.  That's not how things tend to pan out if the
> > protocol is useful.  The url path could be hacked to imply the
> subprotocol
> > but if that's not standardized it's still a mess.  And the subprotocol
> > binding may be orthogonal to the url layout complicating things
> needlessly.
> > >
> > > -Andy
> > >
> > >>  * Web API Spec draft: https://wicg.github.io/web-transport/
> > >>  * Discussion on use cases:
> > >>    https://discourse.wicg.io/t/webtransport-proposal/3508
> > >> Cheers,
> > >>   Victor.
> > >> _______________________________________________
> > >> hybi mailing list
> > >> [email-masked]
> > >> https://www.ietf.org/mailman/listinfo/hybi
> > >
> >
> > _______________________________________________
> > dispatch mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/dispatch
> >
> -------------- next part --------------
> An HTML attachment was scrubbed...
> URL: <
> https://mailarchive.ietf.org/arch/browse/hybi/attachments/20190723/6a4ac121/attachment.html
> >
>
> ------------------------------
>
> Subject: Digest Footer
>
> _______________________________________________
> hybi mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/hybi
>
>
> ------------------------------
>
> End of hybi Digest, Vol 94, Issue 1
> ***********************************
>

-- 
Regards,
Scott Morgan
President & CEO
Adligo Inc
http://www.adligo.com
https://www.linkedin.com/in/scott-morgan-21739415
A+ Better Business Bureau Rating
<https://www.bbb.org/chicago/business-reviews/computer-software-publishers-and-developers/adligo-inc-in-chicago-il-88381256>
https://github.com/adligo

By Appointment Only:
1-866-968-1893 Ex 101
[email-masked]
skype:adligo1?call
Send Me Files Securely:
*https://www.sendthisfile.com/f.jsp?id=ewOnyeFQM18IDRf7MMIdolfI
<https://www.sendthisfile.com/f.jsp?id=ewOnyeFQM18IDRf7MMIdolfI>*